Remove Duplicates from Sorted Array II Leetcode Solution

Difficulty Level Medium
Frequently asked in Adobe Amazon Apple Facebook Google Microsoft
Array Two PointersViews 4663

Problem Statement :

Given an integer array of nums sorted in non-decreasing order, remove some duplicates in place such that each unique element appears at most twice. The relative order of the elements should be kept the same.

Since it is impossible to change the length of the array in some languages, you must instead have the result be placed in the first part of the array nums. More formally, if there are k elements after removing the duplicates, then the first k elements of nums should hold the final result. It does not matter what you leave beyond the first k elements.

Return k after placing the final result in the first k slots of nums.

Do not allocate extra space for another array. You must do this by modifying the input array in place with O(1) extra memory.

Custom Judge:

The judge will test your solution with the following code:

int[] nums = [...]; // Input array
int[] expectedNums = [...]; // The expected answer with correct length

int k = removeDuplicates(nums); // Calls your implementation

assert k == expectedNums.length;
for (int i = 0; i < k; i++) {
    assert nums[i] == expectedNums[i];
}

If all assertions pass, then your solution will be accepted.

Example :

Example 1 

Input: nums = [1,1,1,2,2,3]
Output: 5, nums = [1,1,2,2,3,_]
Explanation: Your function should return k = 5, with the first five elements of nums being 1, 1, 2, 2 and 3 respectively.
It does not matter what you leave beyond the returned k (hence they are underscores).

Example 2 

Input: nums = [0,0,1,1,1,1,2,3,3]
Output: 7, nums = [0,0,1,1,2,3,3,_,_]
Explanation: Your function should return k = 7, with the first seven elements of nums being 0, 0, 1, 1, 2, 3 and 3 respectively.
It does not matter what you leave beyond the returned k (hence they are underscores).

Constraints :

1 <= nums.length <= 3 * 104
-104 <= nums[i] <= 104
nums is sorted in non-decreasing order.

Intuition :

  • Since the array is sorted, all duplicates will be consecutive. So we can use two pointers algorithm.
  • One pointer will iterate the nums array i.e. itr and the other i.e. length will point to the index of the same nums array but before this length index, all the elements count of nums is not more than 2.

Algorithm :

  • Take a variable length and point it with the element at the 0th index of the array nums.
  • Take a variable countElement and initialize it with 1 as we are already escaping the 0th index.
  • Take a variable itr and initialize it with 1, as itr will iterate the nums.
  • If nums[itr]==nums[itr-1] and countElement is less than 2 then we can put the elements nums[itr] in the position of length, after putting increment the length variable.
  • Else if nums[itr] !=nums[itr-1] then nums[itr] is the new element, so again our count element will be  equal to 1,
  • At last return length+1 variable, as length working as an index and we need to return length.
  • Go through the code for a better understanding

Code for Remove Duplicates from Sorted Array II :

Remove Duplicates from Sorted Array II Leetcode Java Solution:

class Solution {
    public int removeDuplicates(int[] nums) {
        int n=nums.length;
        int itr=1;
        int length=0;
        int countElement =1;
        while(itr<n){
            if(nums[itr]==nums[itr-1]){
                if(countElement<2){
                    countElement++;
                    length++;
                    nums[length]=nums[itr];
                }  
            }
            else{
                countElement=1;
                length++;
                nums[length]=nums[itr];
            }
           itr++; 
        }
        return length+1;
    }
}

Remove Duplicates from Sorted Array II Leetcode C++ Solution:

class Solution {
public:
    int removeDuplicates(vector<int>& nums) {
         int n=nums.size();
        int itr=1;
        int length=0;
        int countElement =1;
        while(itr<n){
            if(nums[itr]==nums[itr-1]){
                if(countElement<2){
                    countElement++;
                    length++;
                    nums[length]=nums[itr];
                }  
            }
            else{
                countElement=1;
                length++;
                nums[length]=nums[itr];
            }
           itr++; 
        }
        return length+1;
    }
};

Complexity Analysis for Remove Duplicates from Sorted Array II :

Time Complexity

The time complexity of the above code is O(N) since we traverse the entire input array once in the worst case where N = size of the input array.

Space Complexity 

The Space Complexity of the above solution is O(1) since we’re using the constant extra space.

Translate »